<?php 
namespace WCOA\classes\frontend;

class OrderItemTable
{
	//rplc: woocommerce-order-approval, wcoa, WCOA
	public function __construct()
	{
		add_filter( 'woocommerce_order_item_class', array( &$this, 'manage_order_item_css_class' ), 10, 3);          //Rejected product css text (order details page)
		//add_filter( 'woocommerce_order_item_name', array( &$this, 'manage_order_item_name' ), 10, 3);          		 //Rejected product text (email)
		add_filter( 'woocommerce_order_item_meta_start', array( &$this, 'manage_order_item_name' ), 10, 4);          //Rejected product text (email)
		
	}	
	
	public function manage_order_item_css_class($class, $item, $order)
	{
		global $wcoa_order_model;
		
		wp_enqueue_style('wcoa-order-item-table',  WCOA_PLUGIN_PATH.'/css/frontend-order-item-table.css');
		
		if (get_class($item) != "WC_Order_Item_Product")
			return $class;
		
		if($wcoa_order_model->get_order_item_approval_data($item->get_id()) != 'approved')
		{
			$class .=" wcoa-line-item-rejected ";
		}
		return $class;
	}
	public function manage_order_item_name($item_id, $item, $order, $plain_text)
	{
		global $wcoa_order_model;
		$approval_status = $wcoa_order_model->get_order_item_approval_data($item_id);
		
		// Only for email notifications
		if( is_wc_endpoint_url() ) 
			return;

		if($approval_status == 'rejected')
				echo "<span style='display: block; border: 2px solid #f02121; margin: 10px 0px 10px 0px; padding: 10px; color: #f02121; text-align: center; font-weight: bold;'>".esc_html__('Rejected', 'woocommerce-order-approval')."</span>";
	}
}
?>