"use strict";
	
jQuery(document).ready(function()
{
	jQuery( "#wcoa_datetime_picker" ).datetimepicker({
		dateFormat: 'yy-mm-dd',
		timeFormat: 'HH:mm'
		});	
		
	jQuery(document).on('change', '.wcoa-order-item-approval-selector', wcoa_update_order_items_table )
});
function wcoa_update_order_items_table(event)
{
	var formData = new FormData();
	var id = jQuery(event.currentTarget).data('id');
	var input_name = 'input[name="line_total['+id+']"]';
	formData.append('action', 'wcoa_update_admin_order_items_table'); 	
	formData.append('order_id', wcoa.order_id); 	
	formData.append('security',  wcoa.security); 	
	formData.append('id',  id); 	
	formData.append('value',  jQuery(event.currentTarget).val()); 	
	
	//UI
	wcoa_block_order_items_table();
	
	jQuery.ajax({
		url: ajaxurl,
		type: 'POST',
		data: formData,
		async: true,
		success: function (response) 
		{
			//UI
			wcoa_unblock_order_items_table();
			/* wcoa_reloader_admin_order_items_table.init_tiptip();
			wcoa_reloader_admin_order_items_table.stupidtable.init();
			jQuery( document ).trigger( 'items_saved' ); */
			var result = JSON.parse(response);
			jQuery(input_name).val(result.total);
			jQuery(input_name).data('total',result.total);
			jQuery( '#woocommerce-order-items button.save-action' ).trigger( 'click' ); 		//The order item total has already been saved via the current ajax request. This is triggered only to update the item table. This is useful if the user clicks "no" to the confirm dialog displayed by the "recalculate" button triggering.
		    jQuery( '#woocommerce-order-items button.calculate-action' ).trigger( 'click' );    //Recalculates the order total and taxes
			
		},
		error: function (data) 
		{
			//console.log(data);
			//alert("Error: "+data);
		},
		cache: false,
		contentType: false,
		processData: false
	});
}
//UI (Copied from WooCommerce meta-boxes-order.js)
function wcoa_block_order_items_table()
{
	jQuery( '#woocommerce-order-items' ).block({
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			});
}
function wcoa_unblock_order_items_table()
{
	jQuery( '#woocommerce-order-items' ).unblock();
}
var wcoa_reloader_admin_order_items_table = {
		init_tiptip: function() {
					jQuery( '#tiptip_holder' ).removeAttr( 'style' );
					jQuery( '#tiptip_arrow' ).removeAttr( 'style' );
					jQuery( '.tips' ).tipTip({
						'attribute': 'data-tip',
						'fadeIn': 50,
						'fadeOut': 50,
						'delay': 200,
						'keepAlive': true
					});
				},

		stupidtable: {
					init: function() {
						jQuery( '.woocommerce_order_items' ).stupidtable();
						jQuery( '.woocommerce_order_items' ).on( 'aftertablesort', this.add_arrows );
					},

					add_arrows: function( event, data ) {
						var th    = jQuery( this ).find( 'th' );
						var arrow = data.direction === 'asc' ? '&uarr;' : '&darr;';
						var index = data.column;
						th.find( '.wc-arrow' ).remove();
						th.eq( index ).append( '<span class="wc-arrow">' + arrow + '</span>' );
					}
				}
}